
#------------------------------------------------------------------------------------------------------------------------
# Abfallkalender 2013
# Hier einfach die Tage-im-Monat nacheinander fr Jan-Dez eintragen. 
# Die Monate ergeben sich automatisch.
@gelb=qw( 11  25 8 22 8 22 6 19 4 17 1 14 28 12 26 9 23 6 20 5 18 2 15 29 13 28);
@bio=qw(4 17 31 15 28 14 28 11 25 10 24 6 20 4 18 1 15 29 12 26 10 24 7 21 5 19);
@hm1=qw(2 15 29 13 26 12 26 9 23 7 22 4 18 2 16 30 13 27 10 24 8 22 5 19 3 17 31);
@blau=qw(10 7 7 5 3 31 27 25 22 19 17 14 12 );
@sonder=qw(11 1 15 5 3 21 19 2 6 4 22 6);
#@buendel=qw(10.1. 27.3. 28.11); # nicht implementiert.
#------------------------------------------------------------------------------------------------------------------------
@monate=(31,28,31,30,31,30,31,31,30,31,30,31);
@kuerzel=qw(Jan Feb Mar Apr Mai Jun Jul Aug Sep Okt Nov Dez);
#  0    1           2        3          4         5         6          7        8
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =  localtime(time + 600); # 10 Minuten draufrechnen
                                                                                             #  (Zeit zum Compilieren, Flashen + Installieren)
$jahr=1900+$year;
$monat=$mon+1;
$ist_schaltjahr = ($jahr % 4 == 0) && ($jahr % 100 != 0) || ($jahr % 400 == 0);
$daysInYear=365;
if ($ist_schaltjahr){
	$monate[1] = 29;
	$daysInYear++;
};
$ydayTomorrow = $yday; # Da die interne Uhr 6h vor geht wird am Vorabend ausgeklappt
for ($i=1; $i<=$daysInYear; $i++){
  $all[$i] =0;	
}

for ($i=1; $i<12; $i++){
	$msum[$i+1]=$msum[$i]+$monate[$i-1];
}

#            Wert    Tonne
# P:  		1     Papier
#  G   	2     Gelber Sack
# HM1 	4     Hausmll
#  B   	8     Biotonne
#  S  		16     Schadstoffmobil/Tannenbaum/Grnschnitt(Bndel)

$m=0;
$d=999;
foreach $day(@gelb){
  $m++ if ($d > $day); 
  $d=$day;  
  print "G $day.$m\n";
  $all[$day+$msum[$m]] |= 2; 
}
$m=0;
$d=999;
foreach $day(@bio){
  $m++ if ($d > $day); 
  $d=$day;  
  print "B $day.$m\n";
  $all[$day+$msum[$m]] |= 8; 
}
$m=0;
$d=999;
foreach $day(@hm1){
  $m++ if ($d > $day); 
  $d=$day;  
  print "HM1 $day.$m\n";
  $all[$day+$msum[$m]] |= 4; 
}

$m=0;
$d=999;
foreach $day(@blau){
  $m++;
  $m-- if (($day-$d) > 25) ;  # 2 Termine im Mai
  $d=$day;  
  print "P $day.$m\n";
  $all[$day+$msum[$m]] |= 1; 
}

$m=0;
$d=999;
foreach $day(@sonder){
  $m++;
  $d=$day;  
  print "S $day.$m\n";
  $all[$day+$msum[$m]] |= 16; 
}


#Auf jetzige Uhrzeit 24-18Uhr=6 Stunden draufrechnen (interne Zeit)
  $x = $hour + 6;
  if ($x>23){
    $x-=24;
    $ydayTomorrow++;
  }
  $x *=3;
  $x += int($min/20);          
  $x %=72;
  $m20 = 72 - $x;  #20Min Zeitrume bis Tag rum

  $x = int(int($min % 20)*60/8); 
  $s8 = 150 - $x;  #8s Zeitrume bis 20 Min rum

open (OUT, ">kalender.inc");

$header=<<EOT;
/* generated by kalendergenerator.pl */

inline void initClock(void){
  // Startwert der Uhr setzen (Dann lege ich die Batterien ein)
  //  $jahr-$monat-$mday  $hour Uhr $min 
  m20 = $m20;  //20-Minuten Intervalle bis 18:00
  s8  = $s8;  //8-Sekunden Intervalle die dann bis 18:00 Uhr noch fehlen
  day = $ydayTomorrow;  //Tag im Jahr
}
// ------------ Definition des Abfallkalenders -----------
/* P:  1     Papier
   G   2     Gelber Sack
   HM1 4     Hausmll
   B   8     Biotonne
   S  16     Schadstoffmobil/Tannenbaum/Grnschnitt(Bndel)
   
   Bei mehreren Tonnen an einem Tag: Werte aufsummieren.
*/
EOT
print  OUT $header;
print  OUT "const U8 abfallkalender[".$daysInYear."]={\n  /*       ";
for ($i=1; $i<32; $i++){
  printf OUT ("%2d ",$i);	
}  
print OUT "*/\n  /* Jan */";

$n=1;
$m=1;
for ($i=1; $i< $daysInYear; $i++){
  printf OUT  ("%2d,",$all[$i]);
 $n++;
  if ($n > $monate[$m-1]){
    $n=1;
    print OUT  "\n" if (! ($m % 3));
    print OUT  "\n  /* $kuerzel[$m] */";
    $m++;
  }
}
printf OUT  ("%2d\n};\n",$all[$daysInYear]);
close OUT;

print "kalender.inc erzeugt. Druecke ENTER.\n";
getc();
